#include <iostream>
#define MAX 1000

using namespace std;

void scanFarm(int);
int findMinX(int, int);
int findMiniY(int, int);
int findMaxX(int, int);
int findMaxY(int, int);
bool checkRect(int, int);
int findNumOfNices(int,int);
int allNums(int N, int K);

int vrste[MAX];
int farma[MAX][MAX];
int main()
{
    int N, K;

    scanf("%d%d", &N, &K);

    scanFarm(N);
    int counts = 0;
    counts = findNumOfNices(N, K);
    printf("\n%d", counts);
}

void scanFarm(int N){
    for(int i = 0; i < N; i++){
        for(int j = 0; j < N; j++){
            scanf("%d", &farma[i][j]);
        }
    }
}

int findMinX(int N, int x){
    int mini = N-1;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < N; j++){
            if(farma[i][j] == x && mini > j){
                mini = j;
            }
        }
    }
    return mini;
}

int findMinY(int N, int x){
    int mini = N-1;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < N; j++){
            if(farma[i][j] == x && mini > i){
                 mini = i;
            }
        }
    }
    return mini;
}

int findMaxX(int N, int x){
    int maxi = 0;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < N; j++){
            if(farma[i][j] == x && maxi < j){
                maxi = j;
            }
        }
    }
    return maxi;
}

int findMaxY(int N, int x){
    int maxi = 0;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < N; j++){
            if(farma[i][j] == x && maxi < i){
                maxi = i;
            }
        }
    }
    return maxi;
}

bool checkRect(int N, int x){
    int minY = findMinY(N, x);
    int minX = findMinX(N, x);
    int maxY = findMaxY(N, x);
    int maxX = findMaxX(N, x);

    for(int i = minY; i <= maxY; i++){
        for(int j = minX; j <= maxX; j++){
            if(farma[i][j] != x){
                return false;
            }
        }
    }
    return true;
}
int allNums(int N, int K){
    int z = 0, j = 0, i = 0;
    for(int x = 0; x <= K; x++){
        for(i = 0; i < N; i++){
            for(j = 0; j < N; j++){
                if(farma[i][j] == x){
                    vrste[z] = x;
                    z++;
                    break;
                }
            }
            if(farma[i][j] == x){
                    break;
            }
        }
    }
    return z;
}

int findNumOfNices(int N,int K){
    int counts = 0;
    int z = allNums(N, K);

    for(int i = 0; i < z; i++){
        if(checkRect(N, vrste[i])){
            counts++;
        }
    }
    return counts;
}